package test;

/**
 * @author Kuba
 */
abstract public class Objekt2D {

    int x, y;

    Objekt2D(int x, int y){
        this.x = x;
        this.y = y;
    }

    public void moveLeft(int distance) {
        x -= distance;
        repaint();
    }

    public void moveRight(int distance) {
        x += distance;
        repaint();
    }

    public void moveUp(int distance) {
        y -= distance;
        repaint();
    }

    public void moveDown(int distance) {
        y += distance;
        repaint();
    }

    abstract void repaint();

    public static void main(String[] args) {
        Rectangle r = new Rectangle(2,3);
        Triangle t = new Triangle(200,500);
        r.moveRight(5);
        t.moveUp(10);
    }
}

class Rectangle extends Objekt2D{

    Rectangle(int x, int y){super(x, y);};

    @Override
    void repaint() { 
        System.out.println("Rectangle: " + x + ", " + y);
    }
}

class Triangle extends Objekt2D{

    Triangle(int x, int y){super(x, y);};

    @Override
    void repaint() { 
        System.out.println("Triangle: " + x + ", " + y);
    }
}